diff --git a/imap/imap.c b/imap/imap.c
index 90820cfb9f..ffa185ceae 100644
--- a/imap/imap.c
+++ b/imap/imap.c
@@ -2045,6 +2045,7 @@ static int imap_mbox_open(struct Mailbox *m)
   struct ImapAccountData *adata = imap_adata_get(m);
   struct ImapMboxData *mdata = imap_mdata_get(m);
 
+  adata->prev_mailbox = adata->mailbox;
   adata->mailbox = m;
 
   /* clear mailbox status */
@@ -2314,7 +2315,7 @@ static int imap_mbox_close(struct Mailbox *m)
       adata->state = IMAP_AUTHENTICATED;
     }
 
-    adata->mailbox = NULL;
+    adata->mailbox = adata->prev_mailbox;
     imap_mdata_cache_reset(m->mdata);
   }
 
diff --git a/imap/imap_private.h b/imap/imap_private.h
index 1552fb605f..8596de2870 100644
--- a/imap/imap_private.h
+++ b/imap/imap_private.h
@@ -204,6 +204,7 @@ struct ImapAccountData
 
   char delim;
   struct Mailbox *mailbox;     /* Current selected mailbox */
+  struct Mailbox *prev_mailbox;/* Previously selected mailbox */
   struct Account *account;     ///< Parent Account
 };
 
